/**
 * Created by Zack on 2018/4/16.
 */
var wb = wb || {};
//礼包消耗配置
wb.HjConsumeCfg  =  wb.BaseCfgItem.extend({
   data:{
      id:0,                //礼包id         唯一
      flag:0,              //礼包开关      1开 其他是关
      dtime:0,              //持续时间
      jg_time:0,           //间隔时间
      ctime:0,             //当前时间
      priority:0,          //优先级        越小优先级越高
      dayCounts:0,          //每天可购买/领取次数
      counts:0,             //购买/领取 次数 ---原始次数
      limitCount:0,        //可购买/领取 总次数

      dcCounts:0,      //每天可展示次数
      duCounts:0, //可展示总次数
      dDate:0              //日期
   },
});


//礼包配置
wb.HjGiftConfig = wb.BaseCfgItem.extend({
   data:{
      id:0,                //礼包id         唯一
      switch1:0,           //礼包开关      1开 其他是关
      name:"",             //礼包名称
      items:[],            //道具id
      itemNum:[],          //道具数量
      fee_id:0,            //计费点id        大于0 且计费文件存在该计费点该才可用
      dtime:0,              //持续时间
      jg_time:0,           //间隔时间
      text:"",             //支付文字
      text_zone:[],        //文字坐标
      button:0,            //0为【立即购买】，1为【领取奖励】，2为【立即前往】，3为【知道了】
      main_zone:[],        //按钮坐标
      jump:0,              //跳转页面
      icon:"",             //入口 图标
      icon_path:"",        //入口 图标路径
      picture:"",          //图片
      picture_path:"",     //图片 路径
      icon_url:"",         //入口 图标 url
      picture_url:"",      //图片 url
      close_zone:[],       //关闭按钮坐标
      limit1:[],           //累计付费            第一位为最小值，第二位为最大值
      limit2:[],           //累计登录天数         第一位为最小值，第二位为最大值
      limit3:[],           //最高关卡数           第一位为最小值，第二位为最大值
      limit4:[],           //本次登录天数与上次登录天数的差值   第一位为最小值，第二位为最大值
      limit5:[],           //距离上次付费间隔的天数   第一位为最小值，第二位为最大值
      priority:0,          //优先级                   越小优先级越高
      purchaseLimit:0,     //购买/领取次数
      show:0,              //展示位置                   1 主页
      popout1:0,           //登录选关    每天弹出次数
      popout2:0,           //退回选关    单关失败次数
      popout3:[],          //结算
      popout4:[],          //暂停
      popout5:[],          //复活
      popout6:[],          //关卡失败
      popout7:[],          //签到
      popout8:0,           //失败次数
      popout9:[],          //道具购买
      popout10:"",         //保留位置2
      param1:[],           //保留位置1      倒计时位置
      param2:"",           //保留位置2      每天可购买次数
      param3:0,           //保留位置3      是否可以分享
      param4:"0",           //保留位置4     观看视频广告次数 达到次数后才可弹出
      param5:""           //保留位置5
   },
   ctor:function()
   {
     this.data = {};
   },
   parseData:function(data)
   {
      if(data && data.length>2)
      {
         this.data.id = this.str2Int(data[0]);
         this.data.switch1 = this.str2Int(data[1]);
         this.data.name = data[2];
         this.data.items = this.str2Array(data[3]);
         this.data.itemNum =this.str2Array(data[4]);
         this.data.fee_id =  this.str2Int(data[5]);
         this.data.dtime =  this.str2Int(data[6]);
         this.data.jg_time =  this.str2Int(data[7]);
         this.data.text = data[8];
         this.data.text_zone = this.str2Array(data[9]);
         this.data.button = this.str2Int(data[10]);
         this.data.main_zone = this.str2Array(data[11]);
         this.data.jump =  this.str2Int(data[12]);
         this.data.icon = data[13];
         this.data.picture = data[14];
         this.data.icon_url = data[15];
         this.data.picture_url = data[16];
         this.data.close_zone = this.str2Array(data[17]);
         this.data.limit1 = this.str2Array(data[18]);
         this.data.limit2 = this.str2Array(data[19]);
         this.data.limit3 = this.str2Array(data[20]);
         this.data.limit4 = this.str2Array(data[21]);
         this.data.limit5 = this.str2Array(data[22]);
         this.data.priority = this.str2Int(data[23]);
         this.data.purchaseLimit =  this.str2Int(data[24]);
         this.data.show =  this.str2Int(data[25]);
         this.data.popout1 =   this.str2Int(data[26]);
         this.data.popout2 =   this.str2Int(data[27]);
         this.data.popout3 =  this.str2Array(data[28]);
         this.data.popout4 =  this.str2Array(data[29]);
         this.data.popout5 =  this.str2Array(data[30]);
         this.data.popout6 =  this.str2Array(data[31]);
         this.data.popout7 =  this.str2Array(data[32]);
         this.data.popout8 = this.str2Int(data[33]);
         this.data.popout9 =  this.str2Array(data[34]);
         this.data.popout10 = data[35];
         this.data.param1 =  this.str2Array(data[36]);
         this.data.param2 =  data[37];
         this.data.param3 =  this.str2Int(data[38]);
         this.data.param4 =  data[39];
         this.data.param5 =  data[40];
         this.data.icon_path = wb.frameworkResPath + this.data.icon;
         this.data.picture_path = wb.frameworkResPath + this.data.picture;

      }
   },
   /**
    * @method    是否包含某位置
    * @param {int} i  位置
    */
   havePos:function(i)
   {
      switch (i)
      {
         case 0:
              return this.data && this.data.show && this.data.show >0;
         case 1:
              return this.data && this.data.popout1 && this.data.popout1 >0;
         case 2:
            return this.data && this.data.popout2 && this.data.popout2 >0;
         case 3:
            return this.data && this.data.popout3 && this.data.popout3.length >0;
         case 4:
            return this.data && this.data.popout4 && this.data.popout4.length  >0;
         case 5:
            return this.data && this.data.popout5 && this.data.popout5.length  >0;
         case 6:
            return this.data && this.data.popout6 && this.data.popout6.length  >0;
         case 7:
            return this.data && this.data.popout7 && this.data.popout7.length  >0;
         case 8:
            return this.data && this.data.popout8 && this.data.popout8 >0;
         case 9:
            return this.data && this.data.popout9 && this.data.popout9.length  >0;
         case 10:
            return this.data && this.data.popout10 && this.data.popout10.length  >0;
      }
      return false;
   }
});

/*
 * @class   礼包layer
 */
wb.HjGiftLayer = wb.BaseLayer.extend({
   giftCfg:null,
   payBackFunc:null,
   shareFlag:false,  //点按钮的时候是否同时调用分享
   ctor: function (cfg) {
      this._super();
      this.giftCfg = cfg;
      this.payBackFunc = null;
      this.shareFlag = false;
      if(!cfg || !this.initUI())
      {
         return false
      }
      return true;
   },

   initUI: function () {
      if(this.giftCfg.picture_url && this.giftCfg.picture_url.length >5)
      {
         var self = this;
         self.setVisible(false);
         cc.loader.loadImg(this.giftCfg.picture_url,
             {isCrossOrigin : false }, function(err, img){
                if(img)
                {
                   var s_gift_pic= new cc.Sprite(img);
                   self.addChild(s_gift_pic,4);
                   s_gift_pic.setPosition(cc.p(cc.director.getWinSize().width / 2 , cc.director.getWinSize().height / 2));
                   self.setVisible(true);
                }
                else
                {
                   self.closeLayer();
                }
             });
      }
      else
      {
         var s_gift_pic = new cc.Sprite(wb.frameworkResPath +this.giftCfg.picture);
         this.addChild(s_gift_pic,4);
         s_gift_pic.setPosition(cc.p(cc.director.getWinSize().width / 2 , cc.director.getWinSize().height / 2));
      }

      if(this.giftCfg.main_zone && this.giftCfg.main_zone.length > 1)
      {
         var str_btn = wb.res.gift_buy_png;
         if(this.giftCfg.button == 0)
         {
            str_btn = wb.res.gift_buy_png;
         }
         else if(this.giftCfg.button == 1)
         {
            str_btn = wb.res.gift_get_png;
         }
         else if(this.giftCfg.button == 2)
         {
            str_btn = wb.res.gift_ok_png;
         }
         else if(this.giftCfg.button == 3)
         {
            str_btn =  wb.res.gift_ok_png;
         }
         var btn_main = new ccui.Button(str_btn);
         this.addChild(btn_main,5);
         btn_main.setPosition(cc.p(this.giftCfg.main_zone[0] , this.giftCfg.main_zone[1]));
         btn_main.addClickEventListener(function()
         {
            if(this.giftCfg.button == 0)
            {
               wb.PayManager.orderPay(this.giftCfg.fee_id);
            }
            else if(this.giftCfg.button == 1)
            {
               this.addGiftReward();
               this.closeLayer();
            }
         }.bind(this));

         if(this.giftCfg.button === 0)
         {
            this.payBackFunc =  function (payParams) {
            if (payParams.getPayResult() != wb.PAY_RESULT_SUCCESS) return;
            var id = payParams.getPayId();
            if(id !== this.giftCfg.fee_id)
            {
               return;
            }
            wb.WBUser.recharge(this.giftCfg.fee_id);
            wb.HjPopupManager.buyOne(this.giftCfg.id);
            this.addGiftReward();
            this.closeLayer();
            }.bind(this);
            wb.PayManager.addPayFinishCallback(this.payBackFunc);
         }
      }

      var btn_close = new ccui.Button(wb.res.gift_close_png);
      this.addChild(btn_close,5);
      btn_close.setPosition(cc.p(this.giftCfg.close_zone[0] , this.giftCfg.close_zone[1]));
      btn_close.addClickEventListener(function()
      {
        this.closeLayer();
      }.bind(this));

      var canShare = this.giftCfg.param3;

      if(canShare > 0)
      {
         this.shareFlag = true;
         if (canShare === 2)
         {
            mShareFlag = false;
         }
         var cb = new ccui.CheckBox(wb.res.gift_qb_png,wb.res.gift_gou_png);

      }

      return true;
   },
   /*
    * @method   添加奖励
    */
   addGiftReward:function()
   {
      //this.data.items = this.str2Array(data[3]);
      //this.data.itemNum =this.str2Array(data[4]);
      //
      if(this.giftCfg.items && this.giftCfg.itemNum)
      {
       for(var i =0 ;i < this.giftCfg.items.length;i++)
       {
          wb.tools.addTool(this.giftCfg.items[i],this.giftCfg.itemNum[i]);
       }
      }
   },
   /*
    * @method   关闭当前layer
    */
   closeLayer:function()
   {
      if(this.payBackFunc)
      {
         wb.PayManager.removePayFinishCallback(this.payBackFunc);
      }
      this.removeFromParent();
   },
   /*
    * @method   支付回调
    * @param [obj] payParams
    */
   payCallFunc: function (payParams) {
      //cc.log("CzlbLayer paySucced " + payParams.getPayResult());
      if (this._paySuccedFunc) return this._paySuccedFunc(payParams);

      if (payParams.getPayResult() != wb.PAY_RESULT_SUCCESS) return;
      wb.showRewardLayer({counts: this.data.diamond, endP: this.data.diamondEndP});
      wb.showToast(wb.PAY_SUCCED_STR);
      wb.addCoin(this.data.diamond);
      this.closeLayer();
   },
   /*
    * @method   自定义回调
    * @param [function] func
    */
   setPayCallFunc: function (func) {
      this._paySuccedFunc = func;
   }
});

/*
 * @class   礼包manager
 */
wb.HjPopupManager ={

   consumeCfgs:[],//消耗配置
   orgGiftItems:[],//原始数据
   netGifgCfg:[],
   inited:false,
   loaded:false,
   init:function()
   {
      if(this.inited) return;
      this.inited = true;
      this.orgGiftItems = [];
      this.netGifgCfg = [];
      this.consumeCfgs = [];
      if(this.loadCfg())
      {
         //数组有数据
         this.fixConsumeCfg();
      }

   },
   /*
    * @method   修正消耗列表
    */
   fixConsumeCfg:function()
   {
      var needsave = false;
      for(var i =0 ;i < this.orgGiftItems.length;i++)
      {
         var bo = false;
         for(var j =0 ;j < this.consumeCfgs.length;j++)
         {
            if(this.orgGiftItems[i].data.id === this.consumeCfgs[j].data.id)
            {
               bo = true;
               if(this.orgGiftItems[i].data.popout1 != this.consumeCfgs[j].data.dcCounts)
               {
                  this.consumeCfgs[j].data.dcCounts = this.orgGiftItems[i].data.popout1;
                  this.consumeCfgs[j].data.dDate =  parseInt(wb.getDate());
               }
               if(this.orgGiftItems[i].data.show >0)
               {
                  this.consumeCfgs[j].data.dtime = this.orgGiftItems[i].data.dtime;
                  this.consumeCfgs[j].data.jg_time = this.orgGiftItems[i].data.jg_time;
               }
               if( this.orgGiftItems[i].data.limitCount !== this.consumeCfgs[j].data.limitCount)
               {
                  this.consumeCfgs[j].data.counts = this.orgGiftItems[i].data.purchaseLimit;
                  this.consumeCfgs[j].data.limitCount = this.orgGiftItems[i].data.purchaseLimit;
               }
               need_save = true;
               break;
            }
         }
         if(!bo)
         {
            need_save = true;
            var citem = new wb.HjConsumeCfg();
            citem.data.id = this.orgGiftItems[i].data.id;
            citem.data.flag = this.orgGiftItems[i].data.switch1;
            citem.data.counts = this.orgGiftItems[i].data.purchaseLimit;
            citem.data.limitCount = this.orgGiftItems[i].data.purchaseLimit;
            citem.data.dayCounts = this.orgGiftItems[i].data.param2;
            citem.data.jg_time = this.orgGiftItems[i].data.jg_time;
            citem.data.dtime = this.orgGiftItems[i].data.dtime;
            if (this.orgGiftItems[i].data.popout1 > 0)
            {
               citem.data.dcCounts = this.orgGiftItems[i].data.popout1;
               citem.data.duCounts = 0;
               citem.data.dDate = parseInt(wb.getDate());
            }
            else
            {
               citem.data.dcCounts = 0;
            }
            //if (this.orgGiftItems[i].data.dtime > 0)
            //{
            //   citem.data.ctime  = -1;
            //}
            //else
            {
               citem.data.ctime  = 0;
            }
            this.consumeCfgs.push(citem);
         }
      }
      var cdate = wb.getDate();
      for(var m =0 ;m< this.consumeCfgs.length;m++)
      {
         if(this.consumeCfgs[m].data.dDate < cdate)
         {
            this.consumeCfgs[m].data.dDate = cdate;
            if(this.consumeCfgs[m].data.dcCounts >0)
            {
               this.consumeCfgs[m].duCounts = this.consumeCfgs[m].data.dcCounts;
               needsave = true;
            }
            if(this.consumeCfgs[m].data.counts >0)
            {
               this.consumeCfgs[m].flag = 1;
               this.consumeCfgs[m].data.dayCounts = this.consumeCfgs[m].data.counts;
               needsave = true;
            }
         }
      }
      if(needsave)
      {
         this.saveCfg();
      }
      if(!this.loaded)
      {
         this.loaded = true;
         this.getNetCfg();
      }
   },
   /*
    * @method   获取网络配置
    */
   getNetCfg:function()
   {
      var para = "pid="+ wb.SysConfig.getPrjid();
      wb.HttpPost(GIFTURL, para, function(sc, rc, response){
         if(response && response.data)
         {
            this.setNetCfg(response.data);
         }
      }.bind(this));
   },
   /*
    * @method   加载配置
    */
   loadCfg:function()
   {
      var ret = false;
      var items = wb.GCUserDefault.getStringForKey("giftCfg","").split('`');
      for(var i = 0 ;i < items.length && items[i] && items[i].length >1; i++)
      {
         ret = true;
         var item = new wb.HjGiftConfig();
         item.parseJsonData(items[i]);
         this.orgGiftItems.push(item);
      }
      var netitems = wb.GCUserDefault.getStringForKey("netGiftCfg","").split('`');
      for(var i = 0 ;i < netitems.length && netitems[i] && netitems[i].length >1; i++)
      {
         ret = true;
         var item = new wb.HjGiftConfig();
         item.parseJsonData(netitems[i]);
         this.netGifgCfg.push(item);
      }
      var citems = wb.GCUserDefault.getStringForKey("consumeGiftCfg","").split('`');
      for(var i =0 ;i < citems.length && citems[i] && citems[i].length >1; i++)
      {
         var citem = new wb.HjConsumeCfg();
         citem.parseJsonData(citems[i]);
         this.consumeCfgs.push(citem);
      }

      if(!ret)
      {
         wb.CSVParse.parseConfig(wb.res.gift_cfg_csv,function(data)
         {
            if(data && data.length > 1)
            {
               for(var i = 2 ;i < data.length;i++)
               {
                  if(data[i].length >0)
                  {
                     var item = new wb.HjGiftConfig();
                     item.parseData(data[i]);
                     if(item.data.icon && item.data.icon.length >0)
                     {
                        item.data.icon_path = wb.frameworkResPath + item.data.icon;
                     }
                     if(item.data.picture && item.data.picture.length >0)
                     {
                        item.data.picture_path = wb.frameworkResPath + item.data.picture;
                     }

                     this.orgGiftItems.push(item);
                  }
               }
               this.fixConsumeCfg();
               this.saveCfg();
            }
         }.bind(this));
      }
      return ret;
   },
   /*
    * @method  保存配置
    */
   saveCfg: function () {
      var str = "";
     if(this.orgGiftItems && this.orgGiftItems.length >0)
     {
        str = "";
        for(var i =0 ;i < this.orgGiftItems.length;i++)
        {
           str += this.orgGiftItems[i].obj2Str();
           str +="`";
        }
        wb.GCUserDefault.setStringForKey("giftCfg",str);
        wb.GCUserDefault.save();
     }

      if(this.netGifgCfg && this.netGifgCfg.length >0)
      {
         str = "";
         for(var i =0 ;i < this.netGifgCfg.length;i++)
         {
            str += this.netGifgCfg[i].obj2Str();
            str +="`";
         }
         wb.GCUserDefault.setStringForKey("netGiftCfg",str);
         wb.GCUserDefault.save();
      }
      if(this.consumeCfgs && this.consumeCfgs.length >0)
      {
         str = "";
         for(var i =0 ;i < this.consumeCfgs.length;i++)
         {
            str += this.consumeCfgs[i].obj2Str();
            str +="`";
         }
         wb.GCUserDefault.setStringForKey("consumeGiftCfg",str);
         wb.GCUserDefault.save();
      }

   },
   /*
    * @method  设置网络配置
    * @param[str] data  配置数据
    */
   setNetCfg:function(data)
   {
      if(data.length >2)
      {
         var tempCfgs = [];
         var arr = JSON.parse(data);
         if(arr && arr.length >0)
         {
            for(var i =0;i < arr.length;i++)
            {
               var item = new wb.HjGiftConfig();
               item.parseJsonData(JSON.stringify(arr[i]));
               tempCfgs.push(item);
            }
         }
         this.netGifgCfg.splice(0,this.netGifgCfg.length);
         this.netGifgCfg = tempCfgs;

         var str = "";
         for(var i =0 ;i < this.netGifgCfg.length;i++)
         {
            str += this.netGifgCfg[i].obj2Str();
            str +="`";
         }
         this.mergeCfg();
      }
   },
   /*
    * @method  根据礼包id获取消耗 config
    * @param[int] id   礼包id
    * @return [obj]
    */
   getConsumeCfgByID:function(id)
   {
      for(var i = 0;i < this.consumeCfgs.length;i++)
      {
         if(this.consumeCfgs[i].data.id === id)
         {
            return this.consumeCfgs[i];
         }
      }
      return null;
   },
   /*
    * @method  根据礼包id获取礼包 config
    * @param[int] id   礼包id
    * @return [obj]
    */
   getCfgByID:function(id)
   {
     for(var i = 0;i < this.orgGiftItems.length;i++)
     {
        if(this.orgGiftItems[i].data.id === id)
        {
           return this.orgGiftItems[i];
        }
     }
      return null;
   },
   /*
    * @method  数组里面是否包含某 item
    * @param[array] arr    数组
    * @param[array] arr    数组
    * @return [bool]
    */
   findItem:function(arr,item)
   {
      if(arr && item)
      {
         for(var i =0;i< arr.length;i++)
         {
            if(arr[i] === item)
            {
               return true;
            }
         }
      }
     return false;
   },
   /*
    * @method  合并配置
    */
   mergeCfg:function()
   {
      var urls = [];
      for(var i = 0;i< this.netGifgCfg.length;)
      {
         var oldcfg = this.getCfgByID(this.netGifgCfg[i].data.id);
         if(oldcfg)
         {
            oldcfg.data = this.netGifgCfg[i].data;
         }
         else
         {
            this.orgGiftItems.push(this.netGifgCfg[i]);
         }
         if(this.netGifgCfg[i].data.icon_url && this.netGifgCfg[i].data.icon_url.length >3)
         {
            urls.push(this.netGifgCfg[i].data.icon_url);
         }
         if(this.netGifgCfg[i].data.picture_url && this.netGifgCfg[i].data.picture_url.length >3)
         {
            urls.push(this.netGifgCfg[i].data.picture_url);
         }
         this.netGifgCfg.splice(0,1);
      }
      if(urls.length >0)
      {
         //先缓存一遍图片
         var loadNetImg = function(err,img)
         {
            urls.splice(0,1);
            if(urls.length >0)
            {
               cc.loader.loadImg(urls[0], {isCrossOrigin: false}, loadNetImg);
            }
         };
         cc.loader.loadImg(urls[0], {isCrossOrigin: false}, loadNetImg);
      }

   },

   /*
    * @method  返回优先级最高的一个礼包
    * @param {int} flag  1礼包 2奖励（暂无）
    * @param {int} pos    要弹出的位置
    * @param {str} ext1    额外数据1
    * @param {str} ext2  额外数据2
    */
   getCanShowId:function(flag,pos,ext1,ext2)
   {
      var gifts = this.getCanShowIds(flag,pos,ext1,ext2);
      if(!gifts || gifts.length<=0 || !gifts[0]) return null;
      var ret = gifts[0];
      for(var i = 0;i< gifts.length;i++)
      {
         if(ret.data.priority > gifts[i].data.priority)
         {
            ret = gifts[i];
         }
      }
      return ret;
   },
   /*
    * @method  查找所有符合条件的礼包配置
    * @param {int} flag  1礼包 2奖励（暂无）
    * @param {int} pos    要弹出的位置
    * @param {str} ext1    额外数据1
    * @param {str} ext2  额外数据2
    * @return[array]    符合条件的配置
    */
   getCanShowIds:function(flag,pos,ext1,ext2)
   {
      var ret =[];
      if(this.orgGiftItems.length >0)
      {
         //礼包出现规则
         var uList=[];
         for(var i =0;i< this.consumeCfgs.length;i++)
         {
            if(this.consumeCfgs[i].data.flag === 1&& this.consumeCfgs[i].data.counts > 0 && flag === parseInt(this.consumeCfgs[i].data.id / 10000))
            {
               if(pos === 1)
               {
                  var temp = false;
                  if(this.consumeCfgs[i].data.ctime > 0)
                  {
                     var c_time = parseInt(new Date().getTime() / 1000) -  this.consumeCfgs[i].data.ctime;
                     if(this.consumeCfgs[i].data.dtime <=0 ||
                         c_time % (this.consumeCfgs[i].data.dtime + this.consumeCfgs[i].data.jg_time) < this.consumeCfgs[i].data.dtime)
                     {
                        temp = true;
                     }
                  }
                  else
                  {
                     this.consumeCfgs[i].data.ctime = parseInt(new Date().getTime() / 1000);
                     temp = true;
                  }
                  if(temp &&  this.consumeCfgs[i].data.dcCounts >0 && this.consumeCfgs[i].data.dcCounts > this.consumeCfgs[i].data.duCounts)
                  {
                     uList.push(this.consumeCfgs[i]);
                  }
               }else if(this.getCfgByID(this.consumeCfgs[i].data.id) && this.getCfgByID(this.consumeCfgs[i].data.id).havePos(pos))
               {
                  uList.push(this.consumeCfgs[i]);
               }
            }
         }

      for(var m =0;m < uList.length;m++)
      {
         var item = this.getCfgByID(uList[m].data.id)
         if(item)
         {
            if(item.data.switch1 !== 1) continue;
            if(item.data.price <=0) continue; //同事加上是否有计费点的判断
            if(item.data.limit1 && item.data.limit1.length >1)
            {
               if(wb.WBUser.userInfo.data.gold / 100 < item.data.limit1[0] || wb.WBUser.userInfo.data.gold / 100 > item.data.limit1[1])
               continue;
            }
            if(item.data.limit2 && item.data.limit2.length >1)
            {
               var sub_day = (new Date().getTime() / 1000 - wb.WBUser.userInfo.data.createTime) / 3600 / 24;
               if(sub_day < item.data.limit2[0] || sub_day > item.data.limit2[1]) continue;
            }
            if(item.data.limit3 && item.data.limit3.length >1)
            {
               if(wb.WBUser.userInfo.data.lv < item.data.limit3[0] || wb.WBUser.userInfo.data.lv > item.data.limit3[1]) continue;
            }
            if(item.data.limit3 && item.data.limit3.length >1)
            {
               if(wb.WBUser.userInfo.data.lv < item.data.limit3[0] || wb.WBUser.userInfo.data.lv > item.data.limit3[1]) continue;
            }
            if(item.data.limit4 && item.data.limit4.length >1)
            {
               var t = wb.WBUser.userInfo.data.login_time - wb.WBUser.userInfo.data.lastloginTime;
               if(t < item.data.limit4[0] || t > item.data.limit4[1]) continue;
            }
            if(item.data.limit5 && item.data.limit5.length >1)
            {
               var t = (new Date().getTime() / 1000) - wb.WBUser.userInfo.data.lastrechargeTime ;
               if(wb.WBUser.userInfo.data.lastrechargeTime <= 0) t = 0;
               if(t < item.data.limit5[0] || t > item.data.limit5[1]) continue;
            }
            var canshow = false;
            if (pos === 0)  //大树界面有入口的
            {
               if (item.data.ctime > 0)
               {
                  var c_t = (new Date().getTime() / 1000) - uList[m].data.ctime;
                  if (uList[m].data.dtime <= 0 || c_t % (uList[m].data.dtime + uList[m].data.jg_time) < uList[m].data.dtime)
                  {
                     canshow = true;
                  }
               }
               else
               {
                  canshow = true;
               }
            }else if(pos ===1)
            {
               canshow = true;
            }
            else if(pos ===2 && ext1 && ext1 >= item.data.popout2 )
            {
               canshow = true;
            }
            else if(pos === 3 && ext1 && this.findItem(item.data.popout3,ext1) )
            {
               canshow = true;
            }
            else if(pos === 4 && ext1 && this.findItem(item.data.popout4,ext1) )
            {
               canshow = true;
            }
            else if(pos === 5 && ext1 && this.findItem(item.data.popout5,ext1) )
            {
               canshow = true;
            }
            else if(pos === 6 && ext1 && this.findItem(item.data.popout6,ext1) )
            {
               canshow = true;
            }

            else if(pos === 8 && ext1 && ext1 >= item.data.popout8 )
            {
               canshow = true;
            }
            else if(pos ===9 && ext1 && this.findItem(item.data.popout9,ext1) )
            {
               canshow = true;
            }
            if(canshow )
            {
               ret.push(item);
            }
         }
      }
      }
      return ret;
   },
   /*
    * @method  弹出礼包
    * @param {int} flag  1礼包 2奖励（暂无）
    * @param {int} pos    要弹出的位置
    * @param {str} ext1    额外数据1
    * @param {str} ext2  额外数据2
    */
   showGiftLayer:function(flag,pos,ext1,ext2)
   {
      var itemCfg = this.getCanShowId(flag,pos,ext1,ext2);
      if(!itemCfg || itemCfg.data.id <=0 ) return null;
      var giftLayer = new wb.HjGiftLayer(itemCfg.data);
      if(giftLayer)
      {
         cc.director.getRunningScene().addChild(giftLayer,1000);
         return giftLayer;
      }
      return null;
   },
   /*
    * @method  礼包展示一次
    * @param {int} id  礼包id
    */
   showOne:function(id)
   {
      var item = this.getConsumeCfgByID(id);
      if(item)
      {
         item.data.duCounts ++;
         if(item.data.duCounts > item.data.dcCounts)
         {
            return -1;
         }
         else
         {
            return 1;
         }
      }
      return 0;
   },
   /*
    * @method  礼包购买一次
    * @param {int} id  礼包id
    */
   buyOne:function(id)
   {
      var item = this.getConsumeCfgByID(id);
      if(item && item.data.counts >0){
         item.data.counts --;
         if(item.data.counts > 0)
         {
            this.saveCfg();
            return -1;
         }
         else
         {
            item.data.flag = 0;
            this.saveCfg();
            if(item.data.dayCounts > 0)
            {
               return -1;
            }
            return 1;
         }
      }
      return 0;
   }
};