/**
 * Created by cc on 2018/5/16.
 */

wb.HTItem = {
    id:"",
    icon:"",
    open:"",
    image:"",
    url:"",
    wxid:"",
    param:""
}

wb.HTConfig ={
    iconList : [],
    bannerList : [],
    plaqueList : [],
    splashList : []
}

wb.HtManager = cc.Class.extend({
    _requestCount:0,//向服务器请求次数
    _localConfig:null,
    _cachedConfig:null,
    _remoteConfig:null,

    init:function(){
        this._localConfig = DefaultHTConfig;
        var cached = wb.getItem("HtConfig",null);
        if(cached)
            this._cachedConfig = JSON.parse(cached);
        this.requestRemoteConfig();
    },

    //getLocalConfig:function(){
    //
    //},
    //getCachedConfig:function(){
    //
    //},
    //getRemoteConfig:function(){
    //
    //},

    getConfig:function(){
        if (this._remoteConfig)
            return this._remoteConfig;
        else if (this._cachedConfig)
            return this._cachedConfig;
        else
            return this._localConfig;
    },

    requestRemoteConfig:function(){
        cc.log("requestRemoteConfig");
        var self = this;
        self._requestCount++;
        var obj = {
            appid : wb.SysConfig.getAppid(),
            pid : wb.SysConfig.getPrjid(),
            lsn : wb.SysConfig.getLsn(),
            channel : wb.SysConfig.getChannel(),
            imei : wb.SysConfig.getImei(),
            imsi : wb.SysConfig.getImsi()
        };
        var encodeValue = wb.base64.encode(JSON.stringify(obj));

        var url = "https://api.vzhifu.net/xyxIconPush?value="+encodeValue;
        cc.log("requestHtConfig:\n"+url);
        wb.HttpFetch.xhrGet(url,function(isSuccess, response){
            if(isSuccess){
                var responseText = response.responseText;
                cc.log("response=\n"+responseText);
                if(responseText.length>0){
                    self._requestCount = 0;
                    self._remoteConfig = JSON.parse(responseText);
                    wb.setItem("HtConfig",responseText);
                }
            }
            else{
                if(self._requestCount < 5){
                    self.requestRemoteConfig();
                }
            }
        });
    },
    getBannerList:function(){
        var config = this.getConfig();
        return config.bannerList;
    },
    getIconList:function(){
        var config = this.getConfig();
        return config.iconList;
    },
    getPlaqueList:function(){
        var config = this.getConfig();
        return config.plaqueList;
    },
    getSplashList:function(){
        var config = this.getConfig();
        return config.splashList;
    }
});

wb.HtManager.sharedInstance = null;
//wb.HtManager.firstUseInstance = true;
wb.HtManager.getInstance = function () {
    if (!wb.HtManager.sharedInstance) {
        //wb.HtManager.firstUseInstance = false;
        wb.HtManager.sharedInstance = new wb.HtManager();
        wb.HtManager.sharedInstance.init();
    }
    return wb.HtManager.sharedInstance;
};

//wb.htManager = wb.HtManager._getInstance();
