/**
 * Created by 宇 on 2018/5/31.
 */
var wb = wb || {};
wb.IconImageMap = [];
wb.HtMenuItem = cc.MenuItemSprite.extend({
    //_img: null,
    //_open: null,
    //_link: null,
    //_icon: null,
    _htItem:null,
    //iconImageMap:null,
    _listener:null,
    _itemSize:null,
    ctor: function (htItem) {
        this._super();
        //var normalSprite = new cc.Sprite();
        //var selectedSprite = new cc.Sprite();
        //var disableSprite = new cc.Sprite();
        //wb.IconImageMap = {};
        if (wb.isNative()) this.initWithCallback(this.onClickMenu);
        else this.initWithCallback(this.onClickMenu, this);
        //this._super(normalSprite, selectedSprite, this.onClickMenu, this);
        //if (wb.isNative()) this.initWithCallback(this.onClickMenu);
        //else this.initWithCallback(this.onClickMenu, this);
        this.loadHtItem(htItem);
        return true;
    },
    setListener:function(listener){
        this._listener = listener;
    },
    loadRemoteIcon: function (url) {
        //if (this.itemNum <= 0) return;
        //var configIconList = this.xyxConfig.getIconList();
        //this.configIconList = wb.uniqueArray(configIconList);
        if(wb.IconImageMap[url])
            this.loadIconCb(wb.IconImageMap[url]);
        else
            cc.loader.loadImg(url, {isCrossOrigin: false}, function(err,img){
                if (err){
                    cc.log("loadErr:"+err+",img: "+img);
                    return;
                }
                wb.IconImageMap[this._htItem.icon] = img;
                this.loadIconCb(img);
            }.bind(this));
    },
    loadIconCb: function (img) {
        var normalSprite = new cc.Sprite(img);
        this.setNormalImage(normalSprite);
        var selectedSprite = new cc.Sprite(img);
        this.setSelectedImage(selectedSprite);
        this.setContentSize(this.getNormalImage().getContentSize());
        if(this._itemSize)
            wb.scaleToSize(this, this._itemSize);
        if(this._listener)
            this._listener(wb.HtMenuItem.Event.OnPresent);
    },

    loadHtItem:function(htItem){
        this._htItem = htItem;
        this.loadRemoteIcon(this._htItem.icon);
    },
    onClickMenu: function () {
        var open = this._htItem.open;
        if(open==="url"){
            var url = this._htItem.url;
            if(url)
                wb.Browser.openInnerWeb(url);
        }
        else if(open==="image"){//打开插屏图片
            this.loadAndOpenImage();
        }
        else if(open==="miniprogram"){
            var programId = this._htItem.wxid;
            var path = this._htItem.param;
            if(programId && path)
                wb.GameHelper.openMiniProgram(programId,path);
        }
        if(this._listener)
            this._listener(wb.HtMenuItem.Event.OnClicked);
    },
    loadAndOpenImage:function(){
        var self = this;
        var htItem = self._htItem;
        if(wb.IconImageMap[htItem.image])
            this.openImage(wb.IconImageMap[htItem.image],htItem);
        else
            cc.loader.loadImg(htItem.image, {isCrossOrigin: false}, function(err, img){
                if (err){
                    cc.log("loadErr:"+err+",img: "+img);
                    return;
                }
                wb.IconImageMap[htItem.image] = img;
                self.openImage(img,htItem);
        });
    },
    setItemSize: function (size) {
        this._itemSize = size;
        wb.scaleToSize(this, this._itemSize);
    },
    openImage:function(img,htItem){
        var plaque = new wb.HtPlaqueLayer(img,htItem);
        cc.director.getRunningScene().addChild(plaque,10);
    }

});

wb.HtMenuItem.Event = {
    OnPresent:0,
    OnClicked:1
};
