/**
 * Created by 宇 on 2018/5/31.
 */
var wb = wb || {};
wb.HtPlaqueLayer = cc.LayerColor.extend({
    _image:null,
    _htItem:null,
    ctor:function(img,htItem){
        var size = cc.director.getWinSize();
        this._super(cc.Color(0,0,0,200),size.width,size.height);
        this._htItem = htItem;
        this._image = new cc.Sprite(img);
        this.addChild(this._image);
        this._image.setPosition(cc.p(size.width/2,size.height/2));
        cc.eventManager.addListener({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: this.onTouchBegan.bind(this),
            onTouchMoved: null,
            onTouchEnded: null
        }, this);

    },
    onTouchBegan:function(touch, event){
        var point = touch.getLocation();
        var rect = this._image.getBoundingBox();
        if(cc.rectContainsPoint(rect,point)){//打开图片
            var areawidth = rect.width/6;
            areawidth = Math.min(100,areawidth)
            var closeRect = cc.rect(
                cc.rectGetMaxX(rect) - areawidth,
                cc.rectGetMaxY(rect) - areawidth,
                areawidth,
                areawidth);

            if(cc.rectContainsPoint(closeRect,point)){//关闭
                this.runAction(cc.removeSelf());
            }
            else {
                var open = this._htItem.open;
                cc.log("onClickPlaque");
                if(open==="url"){
                    var url = this._htItem.url;
                    wb.Browser.openInnerWeb(url);
                }
                else if(open==="miniProgram"){
                    var programId = this._htItem.wxid;
                    var path = this._htItem.param;
                    wb.GameHelper.openMiniProgram(programId,path);
                }
            }
        }
        else{
            this.runAction(cc.removeSelf());
        }
        return true;
    },
    //onTouchMoved:function(){
    //
    //},
    //onTouchEnded:function(){
    //
    //}
})