/**
 * Created by skai1 on 2018/6/5.
 */

var wb = wb || {};
wb.jsSelfTJ =
{
    _url:"https://tj.vzhifu.net/",
    _wxappid:"",
    _openid:"",
    _appid:"",
    _prjid:"",
    init:function(openid,wxappid,appid,prjid)
    {
        if(appid === undefined || appid === "")
        {
            appid = wb.SysConfig.getAppid();
        }
        this._appid = appid;
        this._url = "https://tj.vzhifu.net/" + appid;
        if(openid !== undefined)
        {
            this._openid = openid;
        }
        if(wxappid !== undefined)
        {
            this._wxappid = wxappid;
        }
        if(prjid === undefined || prjid === "")
        {
            prjid = wb.SysConfig.getPrjid();
        }
        this._prjid = prjid;
		this.loginIn();
    },
	loginIn:function()
	{
		this.onEvent("loginin");
	},	

    onEvent:function(eventid,label)
    {
        var type = "custom";
        var eventID = eventid;
        var data = {};
        if(typeof label == "string"){
            data = {
                label:label
            }
        }else if(typeof label == "object"){
            data = label;
        }
        this.reportData(type,eventID,data);
    },
    startLevel:function(levelID){
        var type = "level";
        var eventID = "begin";
        var data = {levelid:levelID};
        this.reportData(type,eventID,data);
    },
    finishLevel:function(levelID){
        var type = "level";
        var eventID = "complete";
        var data = {levelid:levelID};
        this.reportData(type,eventID,data);
    },
    failLevel:function(levelID){
        var type = "level";
        var eventID = "fail";
        var data = {levelid:levelID};
        this.reportData(type,eventID,data);
    },
    setUserData:function(data){
        var type = "acount";
        var eventID = "update";
        this.reportData(type,eventID,data);
    },
    reportData:function(type,eventID,data){
        cc.log("onEvent:type="+type+",eventID="+eventID);
        var tData = {
            type:type,
            eventid:eventID,
            wxappid:this._wxappid,
            openid:this._openid,
            appid:this._appid,
            prjid:this._prjid,
            data:data,
        };
        var base64value = wb.base64.encode(JSON.stringify(tData));
        console.log("base64value="+base64value);
        wb.HttpFetch.xhrPost(this._url,null,base64value);
    }

};
