/**
 * Created by Zack on 2018/1/9.
 */

var wb = wb || {};

wb.Ad = wb.extend(wb.JAd, {});

wb.ADSourceItem = wb.extend(wb.JADSourceItem, {});

wb.ADManager = wb.extend(wb.JADManager, {});

wb.ADManager.openAdO = function (str, int) {
    if (!wb.ADManager.isAdEnable(str)) return false;
    if (wb.ADManager.isAdReady(str) && wb.isNative()) this.parent.openAdO(str, int);
};

wb.ADManager.openAd = function (str) {
    if (!wb.ADManager.isAdEnable(str)) return false;
    if (wb.ADManager.isAdReady(str) && wb.isNative()) this.parent.openAd(str);
};

wb.ADManager.openAdC = function (str, func) {
    if (!wb.ADManager.isAdEnable(str)) return false;
    if (wb.isNative()) {
        if (wb.ADManager.isAdReady(str)) this.parent.openAdC(str, func);
    }
    else if (func) func(null, 0);
};

wb.ADManager.openAdOC = function (str, int, func) {
    if (!wb.ADManager.isAdEnable(str)) return false;
    if (wb.isNative()) {
        if (wb.ADManager.isAdReady(str)) this.parent.openAdOC(str, int, func);
    }
    else if (func) func(null, 0);
};

wb.ADManager.getVideoLimitOpenNum = function () {
    if (wb.isNative()) return this.parent.getVideoLimitOpenNum();
    return 10;
};
wb.ADManager.isAdReady = function (position, type) {
    if (!wb.ADManager.isAdEnable(position)) return false;
    if (wb.isNative()) return this.parent.isAdReady(position);
    else if(wb.isWX())  return false;
    return true;
};

wb.ADManager.isAdEnable = function (position) {
    for (var i = 0; i < wb.adVideoPosition.length; i++) {
        if (wb.adVideoPosition[i] == position) return true;
    }
    return wb.getADEnabled();
};