/**
 * Created by Zack on 2018/1/9.
 */
var wb = wb || {};

wb.GCUserDefault = wb.extend(wb.JGCUserDefault, {});
wb.GCUserDefault.setIntegerForKey = function (key, value) {
    if (wb.isNative()) this.parent.setIntegerForKey(key, parseInt(value));
    else wb.setItem(key, parseInt(value));
}

wb.GCUserDefault.setDoubleForKey = function (key, value) {
    if (wb.isNative()) this.parent.setDoubleForKey(key, parseFloat(value));
    else wb.setItem(key, parseFloat(value));
}
wb.GCUserDefault.setStringForKey = function (key, value) {
    if (wb.isNative()) this.parent.setStringForKey(key, String(value));
    else wb.setItem(key, String(value));
}

wb.GCUserDefault.setBoolForKey = function (key, value) {
    if (wb.isNative()) this.parent.setBoolForKey(key, Boolean(value));
    else wb.setItem(key, wb.boolToStr(Boolean(value)));
}


wb.GCUserDefault.getBoolForKey = function (key, value) {
    if (value == undefined || value == null)  value = false;
    if (wb.isNative()) return this.parent.getBoolForKey(key, value);
    return wb.strToBool(wb.getItem(key, value));
}

wb.GCUserDefault.getStringForKey = function (key, value) {
    if (value == undefined || value == null)  value = "";
    if (wb.isNative()) return this.parent.getStringForKey(key, value);
    return wb.getItem(key, value);
}

wb.GCUserDefault.getIntegerForKey = function (key, value) {
    if (value == undefined || value == null)  value = -1;
    if (wb.isNative()) return this.parent.getIntegerForKey(key, value);
    return parseInt(wb.getItem(key, value));
}
wb.GCUserDefault.getDoubleForKey = function (key, value) {
    if (value == undefined || value == null)  value = -1;
    if (wb.isNative()) return this.parent.getDoubleForKey(key, value);
    return parseFloat(wb.getItem(key, value));
}

wb.GCUserDefault.setItem = function (key, value) {
    if (wb.isInteger(value)) wb.GCUserDefault.setIntegerForKey(key, value);
    else if (wb.isFloat(value)) wb.GCUserDefault.setDoubleForKey(key, value);
    else if (wb.isString(value)) wb.GCUserDefault.setStringForKey(key, value);
    else if (wb.isBoolean(value)) wb.GCUserDefault.setBoolForKey(key, value);
    else cc.log("setItem error!");
}

wb.GCUserDefault.getItem = function (key, value) {
    if (value == undefined || value == null)  value = "";
    if (wb.isNative()) return this.parent.getStringForKey(key, value);
    return wb.getItem(key, value);
}



