/**
 * Created by Zack on 2018/1/9.
 */
var wb = wb || {};

wb.PAY_RESULT_OTHER = -4;      //其它
wb.PAY_RESULT_PAYCODERROR = -3;//计费点错误
wb.PAY_RESULT_UNINIT = -2;     //支付尚未初始化
wb.PAY_RESULT_ERROR = -1;      //支付错误
wb.PAY_RESULT_SUCCESS = 0;     //支付成功
wb.PAY_RESULT_FAIL = 1;        //支付失败
wb.PAY_RESULT_CANCEL = 2;      //支付取消

wb.Pay = wb.extend(wb.JPay, {});
wb.PayParams = wb.extend(wb.JPayParams, {});
wb.FeeItem = wb.extend(wb.JFeeItem, {});
wb.FeeInfo = wb.extend(wb.JFeeInfo, {});

wb.PayManager = wb.extend(wb.JPayManager, {});

wb.PayManager.payCallFuncV = [];

wb.PayManager.payCallFunc = function (payParams) {
    for (var i = 0; i < wb.PayManager.payCallFuncV.length; i++) {
        var func = wb.PayManager.payCallFuncV[i];
        if (func) func(payParams);
    }
};

wb.PayManager.addOnPayFinishCallback = function (func) {
    if (wb.isNative()) return this.parent.addOnPayFinishCallback(func);

    wb.PayManager.payCallFuncV.push(func);
    return wb.PayManager.payCallFuncV.length - 1;
};

wb.PayManager.removeOnPayFinishCallback = function (id) {
    if (wb.isNative()) return this.parent.removeOnPayFinishCallback(id);
    wb.PayManager.payCallFuncV[id] = null;
};

wb.PayManager.orderPay = function (id) {
    if (wb.isNative()) return this.parent.orderPay(id);

    var payParams = {};
    payParams.getPayId = function () {
        return id;
    };
    payParams.getPayResult = function () {
        return wb.PAY_RESULT_SUCCESS;
    };
    this.payCallFunc(payParams);
};

wb.PayManager.orderPay2 = function (id, price) {
    if (wb.isNative()) return this.parent.orderPay2(id, price);

    var payParams = {};
    payParams.getPayId = function () {
        return id;
    };
    payParams.getPayResult = function () {
        return wb.PAY_RESULT_SUCCESS;
    };
    payParams.getPayPrice = function () {
        return price;
    };
    this.payCallFunc(payParams);
};

wb.PayParams = wb.extend(wb.JPayParams, {});
wb.FeeItem = wb.extend(wb.JFeeItem, {});
wb.FeeInfo = wb.extend(wb.JFeeInfo, {});

