/**
 * Created by Zack on 2018/1/9.
 */
var wb = wb || {};

wb.Core = wb.extend(wb.JCore, {});
wb.SysConfig = wb.extend(wb.JSysConfig, {});

if(!wb.isNative()){
    wb.SysConfig.getAppid = function () {
        return "10000";
    };

    wb.SysConfig.getPrjid = function () {
        return "112233";
    };

    wb.SysConfig.getLsn = function () {
        return "152252525";
    };
    wb.SysConfig.getChannel = function () {
        return "wb";
    };
    wb.SysConfig.getImei = function () {
        return "111111111";
    };
    wb.SysConfig.getImsi = function () {
        return "222222222";
    }
}

wb.CoreManager = wb.extend(wb.JCoreManager, {});
wb.CoreManager = wb.extend(wb.JCoreManager, {});

wb.Browser = wb.extend(wb.JBrowser, {});
wb.Browser.openInnerWeb = function (str) {
    if (wb.isNative()) return this.parent.openInnerWeb(str);
    window.open(str);
};

wb.DhmData = wb.extend(wb.JDhmData, {});
wb.ExchangeData = wb.extend(wb.JExchangeData, {});
wb.CDKEY = wb.extend(wb.JCDKEY, {});
wb.Exchange = wb.extend(wb.JExchange, {});
wb.Community = wb.extend(wb.JCommunity, {});
wb.FileUtils = wb.extend(wb.JFileUtils, {});
wb.ZPFileUtils = wb.extend(wb.JZPFileUtils, {});
wb.FileUtils = wb.extend(wb.JFileUtils, {});
wb.response = wb.extend(wb.Jresponse, {});
wb.HttpFetch = wb.extend(wb.JHttpFetch, {});
wb.MMChnl = wb.extend(wb.JMMChnl, {});
wb.MMChnlLocal = wb.extend(wb.JMMChnlLocal, {});
wb.MMChnlNet = wb.extend(wb.JMMChnlNet, {});
wb.MMChnlManager = wb.extend(wb.JMMChnlManager, {});
wb.Notice = wb.extend(wb.JNotice, {});
wb.MMChnlLocal = wb.extend(wb.JMMChnlLocal, {});
wb.Notification = wb.extend(wb.JNotification, {});
wb.Rank = wb.extend(wb.JRank, {});
wb.Signature = wb.extend(wb.JSignature, {});
wb.UserAgreement = wb.extend(wb.JUserAgreement, {});
wb.XYXConfig = wb.extend(wb.JXYXConfig, {});

wb.XYXManager = wb.extend(wb.JXYXManager, {});
wb.XYXManager.getConfig = function () {
    if (wb.isNative()) return this.parent.getConfig();
    var config = {};
    config.getOpenList = function () {
        return wb.XYXConfigTest.openUrlList;
    };
    config.getImageList = function () {
        return wb.XYXConfigTest.imgUrlList;
    };
    config.getLinkUrlList = function () {
        return wb.XYXConfigTest.linkUrlList;
    };
    config.getIconList = function () {
        return wb.XYXConfigTest.iconUrlList;
    };
    config.getParamList = function () {
        return wb.XYXConfigTest.paramList;
    };
    config.getAdShowUrl = function(){
        return "";
    };
    config.getAdClickUrl = function(){
        return "";
    };
    return config;
};

wb.XYXManager.getListLength = function () {
    if (wb.isNative()) return this.parent.getConfig().getIconList().length;
    return wb.XYXConfigTest.iconUrlList.length;
};


wb.HttpFetch.xhrGet = function (url, func) {

    var xhr = cc.loader.getXMLHttpRequest();
    xhr.timeout = 300000;
    if (!xhr.onreadystatechange) {
        xhr.onreadystatechange = function () {
            cc.log("xhr.readyState = "+xhr.readyState);
            if (xhr.readyState == 4){
                if (xhr.status >= 200 && xhr.status <= 207 && func)  {
                    //cc.log("statusText = "+xhr.statusText) ;
                    //var responseText = xhr.responseText;
                    //cc.log("response:\n" + responseText);
                    func(true,xhr);
                }
                else if(func){
                    cc.log("status = "+xhr.status) ;
                    cc.log("statusText = "+xhr.statusText) ;
                    func(false, xhr);
                }
            }

        };
    }
    xhr.open("GET", url,true);
    if(wb.isNative())
        xhr.setRequestHeader("content-type","text/plain;charset=UTF-8");
    else
        xhr.setRequestHeader('content-type', "application/x-www-form-urlencoded");
    xhr.send();
}

wb.HttpFetch.xhrPost = function(url,func,value){
    var xhr = cc.loader.getXMLHttpRequest();
    xhr.timeout = 300000;
    if (!xhr.onreadystatechange) {
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4){
                if (xhr.status >= 200 && xhr.status <= 207 && func) {
                    func(true,xhr);
                }
                else if(func){
                    func(false,xhr);
                }
            }
        };
    }
    xhr.open("POST", url,true);
    if(wb.isNative())
        xhr.setRequestHeader("content-type","text/plain;charset=UTF-8");
    else
        xhr.setRequestHeader('content-type', 'application/x-www-form-urlencoded');
    xhr.send(value);
};