/**
 * Created by Zack on 2018/4/16.
 */
var wb = wb || {};

wb.CSVParse ={
    CSVToArray:function ( strData, strDelimiter ,length) {
        strDelimiter = (strDelimiter || ",");
        var objPattern = new RegExp(
            (
                "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +
                "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +
                "([^\"\\" + strDelimiter + "\\r\\n]*))"
            ),
            "gi"
        );
        var arrData = [[]];
        var arrMatches = null;
        while (arrMatches = objPattern.exec( strData )){
            var strMatchedDelimiter = arrMatches[ 1 ];
            if (
                strMatchedDelimiter.length &&
                (strMatchedDelimiter != strDelimiter)
            ){
                arrData.push( [] );
            }
            if (arrMatches[ 2 ]){
                strMatchedValue = arrMatches[ 2 ].replace(
                    new RegExp( "\"\"", "g" ),
                    "\""
                );
            } else {
                strMatchedValue = arrMatches[ 3 ];
            }
            if(strMatchedValue.length >= 0)
            {
                arrData[ arrData.length - 1 ].push( strMatchedValue );
            }
        }
        //去掉空行
        for(var i =0 ;i < arrData.length;i++)
        {
            if(arrData[i].length == 0)
            {
                arrData.splice(i,1);
                i--;
            }
        }
        return arrData;
    },
    parseConfig:function(fileName,func)
    {
        var outDatas = [];
        try{
            var callFUnM = function(err,data){
                if(err){cc.log(err);return;}
                callFUnM.func(wb.CSVParse.CSVToArray(data,","));
            };
            callFUnM.func = func;
            cc.loader.loadTxt(fileName,callFUnM);
        }catch(err){
            cc.log("获取关卡配置表错误："+err);
            return outDatas;
        }
    },
};