/**
 * Created by skay on 2018/5/9.
 */

wb.HjPushItem = wb.BaseCfgItem.extend({
    data:{
        type:0,                   //类型
        mess:"",                  //推送文字
        //description:"",           //对该type的描述
    },
    ctor:function()
    {
        this.data = {};
    },
    parseData:function(data)
    {
        if(data && data.length>1)
        {
            this.data.type = parseInt(data[0]);
            this.data.mess = data[1];
        }
    },
});

wb.HjPushManager ={

    pushCfgs:null,
    init:function()
    {
        this.pushCfgs = {};
        wb.CSVParse.parseConfig(wb.res.push_cfg_csv,function(data)
        {
            if(data && data.length > 1)
            {
                for(var i = 2 ;i < data.length;i++)
                {
                    if(data[i].length >1)
                    {
                        var item = new wb.HjPushItem();
                        item.parseData(data[i]);
                        if(this.pushCfgs[item.data.type+""] === undefined)
                        {
                            this.pushCfgs[item.data.type+""] =[];
                        }
                        this.pushCfgs[item.data.type+""].push(item);
                    }
                }
            }
            this.onResume();
        }.bind(this));
    },
    /**
     * @method 程序从后台进入前台
     */
    onResume:function()
    {
        wb.Notification.cancelAll();
        this.addNotify();
    },
    /**
     * @method 程序进入后台
     */
    onPause:function()
    {
        wb.Notification.cancelAll();
        this.addNotify();
    },
    /**
     * @method 添加定时推送
     */
    addNotify:function()
    {
        if(this.pushCfgs )
        {
            var c_time = wb.getLocalTime() ; //秒级时间
            c_time = 3600 * 24 - c_time % (3600 * 24) ; // 次日0点
            //第一种情况  周末12点推送
            var c_day = new Date().getDay();  //7123456
            var time1 = 0;   //周六推送
            var time2 = 0;   //周日推送
            if(c_day === 6)
            {
                time1 = c_time + (12 + 24 * 6) * 3600;
                time2 = c_time + 12 * 3600;
            }else
            {
                time1 = c_time + (12 + 24 * (6 - c_day)) * 3600;
                time2 = time1 + 24 * 3600;
            }
            if(this.pushCfgs["1"] && this.pushCfgs["1"].length >0)
            {
                wb.Notification.notify(this.pushCfgs["1"][ Math.ceil(Math.random() * this.pushCfgs["1"].length) % this.pushCfgs["1"].length].data.mess,wb.getLocalTime() + time1,1,{}); //周六推送
                wb.Notification.notify(this.pushCfgs["1"][ Math.ceil(Math.random() * this.pushCfgs["1"].length) % this.pushCfgs["1"].length].data.mess,wb.getLocalTime() + time2,1,{});  //周日推送
            }
            //第二种情况 流失一天后晚上18点推送
            if(this.pushCfgs["2"] && this.pushCfgs["2"].length >0)
            {
                wb.Notification.notify(this.pushCfgs["2"][ Math.ceil(Math.random() * this.pushCfgs["2"].length) % this.pushCfgs["2"].length].data.mess,wb.getLocalTime() + c_time + (18)*3600,1,{});
            }
        }
    }
};