/**
 * Created by skay on 2018/5/12.
 */


wb.HjShareItem = wb.BaseCfgItem.extend({
    data:{
        type:0,                   //类型
        mess:"",                  //推送文字
        //id:0,           //对该type的描述
    },
    ctor:function()
    {
        this.data = {};
    },
    parseData:function(data)
    {
        if(data && data.length>1)
        {
            this.data.type = parseInt(data[0]);
            this.data.mess = data[1];
        }
    },
});


wb.HjShareManager = {

    shareCfgs: {},
    init: function () {
        this.shareCfgs = {};
        wb.CSVParse.parseConfig(wb.res.share_cfg_csv, function (data) {
            if (data && data.length > 1) {
                for (var i = 2; i < data.length; i++) {
                    if (data[i].length > 1) {
                        var item = new wb.HjShareItem();
                        item.parseData(data[i]);
                        if(this.shareCfgs[item.data.type+""] === undefined)
                        {
                            this.shareCfgs[item.data.type+""] =[];
                        }
                        this.shareCfgs[item.data.type+""].push(item);
                    }
                }
            }
        }.bind(this));
    },

    /**
     * @method
     * @param {int} type 根据类型取分享内容
     * @param {function} callback 回调
     * @param {str} mess  分享语，为空时从配置中取
     * @param {str} imgurl  分享的网络图片的地址。
     * @param {int} scene  0是窗口 1是朋友圈
     * @param {str} url  分享的链接地址
     */
    share:function(type,callback,mess,imgurl,scene,url)
    {
        var shareinfo =new wb.ShareInfo();
        shareinfo._params ={};
        if(scene ===undefined)
        {
           scene = 1;
        }
        if(mess === undefined)
        {
            mess = "";
            if(type !== undefined)
            {
                if(this.shareCfgs && this.shareCfgs[type+""] && this.shareCfgs[type+""].length > 0)
                {
                    mess = this.shareCfgs[type+""][ Math.ceil(Math.random() * this.shareCfgs[type+""].length) % this.shareCfgs[type+""].length].data.mess;
                }
            }
        }
        if(imgurl === undefined)
        {
            imgurl = "";
        }
        if(url === undefined)
        {
            url = "";
            if(wb.MMChnlManager.getM_mmchnlValues())
            {
                var shareurl = wb.MMChnlManager.getMMChnl().getM_mmchnlValues()["shareurl"];
                if(shareurl !== undefined && shareurl.length >1)
                {
                    url = shareurl;
                }
            }
        }
        shareinfo._params["shareTo"] = scene;
        shareinfo._params["title"] = mess;
        shareinfo._params["url"] = url;
        shareinfo._params["imageUrl"] = imgurl;

        //下面发起分享
        wb.ShareManager.share(shareinfo,callback);
    }


};