/**
 * Created by Zack on 2018/4/16.
 */
var wb = wb || {};

wb.NoAdLayer = wb.BaseLayer.extend({
    data: null,
    _paySuccedFunc: null,
    ctor: function (data) {
        this.initData(data);
        this._super(this.data.jsonPath);
        this.initUI();
        return true;
    },
    onEnter: function () {
        this._super();
        this.popUI("uiPanel", 0);
    },
    onExit: function () {
        this._super();
        if (this.callId) wb.PayManager.removeOnPayFinishCallback(this.callId);
    },
    initData: function (data) {
        if (data) this.data = wb.uniqueObj(wb.noAdData, data);
        else this.data = wb.noAdData;

        this.callId = wb.PayManager.addOnPayFinishCallback(function (payParams) {
            cc.log("NoAdLayer pay~~~~~~~");
            this.payCallFunc(payParams);
        }.bind(this));
    },
    initUI: function () {

        wb.FW(this.rootNode, this.data.btn_close, function () {
            this.closeLayer();
        }.bind(this));

        wb.FW(this.rootNode, this.data.txt_zs).setString(this.data.diamondStr);
        wb.FW(this.rootNode, this.data.txt_price).setString(this.data.priceStr);
        wb.FW(this.rootNode, this.data.btn_buy, function () {
            wb.PayManager.orderPay(this.data.id);
        }.bind(this));


        this.rootNode.runAction(this.object.action);
        this.object.action.play("bt", false);
        this.object.action.setLastFrameCallFunc(function () {
            this.object.action.play("lbguang", true);
            this.object.action.setLastFrameCallFunc(null);
        }.bind(this));
    },
    payCallFunc: function (payParams) {
        cc.log("NoAdLayer paySucced " + payParams.getPayResult());
        if (this._paySuccedFunc) return this._paySuccedFunc(payParams);
        if (this.data.id != payParams.getPayId()) return;
        if (payParams.getPayResult() != wb.PAY_RESULT_SUCCESS) return;

        wb.showRewardLayer({counts: this.data.diamond, endP: this.data.diamondEndP});
        wb.showToast(wb.PAY_SUCCED_STR);
        wb.setADEnabled(false);  // 设置广告字段
        wb.addCoin(this.data.diamond);
        this.closeLayer();
    },
    // 自定义回调
    setPayCallFunc: function (func) {
        this._paySuccedFunc = func;
    }
});