/**
 * Created by skai1 on 2018/1/25.
 */

var wb = wb || {};

//获得钻石界面
wb.RewardLayer = wb.BaseLayer.extend({
    sp_root: null,
    counts: 0,
    endP: null,  // 终点

    ctor: function (data) {
        this._super();

        this.setKeyBoardFunc(function () {
        });

        this.counts = data.counts;
        this.endP = data.endP;
        if (!this.endP) this.endP = cc.p(34, 1084);

        this.sp_root = new cc.Node();
        this.sp_root.setPosition(wb.getCenterP());
        this.addChild(this.sp_root);

        var g_spine = new sp.SkeletonAnimation(wb.res.djgx_json, wb.res.djgx_atlas, 1.0);
        g_spine.setAnimation(0, "ty", true);
        this.sp_root.addChild(g_spine);

        var zuan = new cc.Sprite(wb.res.diamond_icon_png);
        zuan.setPosition(cc.p(1, -3));
        this.sp_root.addChild(zuan);

        g_spine.setTag(1);
        zuan.setTag(2);

        var num = new cc.LabelAtlas(":" + this.counts, wb.res.num_dj_zs_fs_sj_png, 19, 26, "0");
        zuan.addChild(num);
        num.setAnchorPoint(cc.p(0.5, 0.5));
        num.setPosition(zuan.getContentSize().width + 10, zuan.getContentSize().height / 4 - 6);
        zuan.setScale(1.2);

        g_spine.setOpacity(0);
        g_spine.runAction(cc.fadeTo(0.6, 230));
        zuan.setScale(0);

        zuan.runAction(cc.sequence(cc.delayTime(0.05), cc.scaleTo(0.2, 1.2), cc.scaleTo(0.1, 0.9), cc.scaleTo(0.1, 1.0)));

        this.scheduleOnce(this.doFlyAction, 2, "schedule_action");

        return true;
    },

    doFlyAction: function () {

        var delayTime = 0;
        if (this.counts > 10) this.counts = 15;

        var rootP = this.sp_root.getPosition();

        for (var i = 0; i < this.counts; i++) {
            var zuan = new cc.Sprite(wb.res.diamond_icon_png);
            zuan.setPosition(cc.p(1, -3));
            zuan.setPosition(rootP);
            this.addChild(zuan, this.counts - i);

            var beziercfg = [rootP, cc.p(this.endP.x, rootP.y), this.endP];
            zuan.runAction(cc.sequence(cc.delayTime(delayTime), cc.bezierTo(0.4, beziercfg), cc.fadeTo(0.15, 0)));
            delayTime += 0.15;
        }
        this.sp_root.removeChildByTag(2);
        this.sp_root.getChildByTag(1).runAction(cc.sequence(cc.delayTime(delayTime - 0.2), cc.fadeTo(0.2, 0)));
        this.runAction(cc.sequence(cc.delayTime(delayTime + 0.4), cc.callFunc(function () {
            wb.EventManager.dispatchCustomEvent(wb.EVENT_COIN_CHANGE, this.counts);
            this.closeLayer();
        }.bind(this))));
    }
});