/**
 * Created by zack on 2018/7/30.
 */

var wb = wb || {};
wb.wx = wb.wx || {};

wb.wxData = wb.wxData || {};

// 推送数据
wb.wxData.pushData = null;
// 分享数据
wb.wxData.shareData = null;
// 用户id
wb.wxData.openid = null;
// 用户信息
wb.wxData.userInfo = null;

wb.wxData.init = function () {
    wb.wxData.initPushData();
    wb.wxData.initLoginData();
};

// 初始分享图数据
wb.wxData.initShareData = function (callFunc) {
    if (wb.wxConfig.wbAppID.length <= 0) return;

    wb.wxTool.httpRequest(wb.wxConfig.wxShareUrl, "appid=" + wb.wxConfig.wbAppID, function (data) {
        wb.wxData.shareData = data;
        if (callFunc) callFunc(data);
        wb.EventManager.dispatchCustomEvent("wxShareData");
    }, false);

};

// 初始推送数据
wb.wxData.initPushData = function (callFunc) {
    if (wb.wxConfig.wbAppID.length <= 0) return;

    wb.wxTool.httpRequest(wb.wxConfig.wxPushUrl, "appid=" + wb.wxConfig.wbAppID, function (data) {
        wb.wxData.pushData = data;
        if (callFunc) callFunc(data);
        wb.EventManager.dispatchCustomEvent("wxPushData");
    }, false);

};

// 初始登陆数据
wb.wxData.initLoginData = function (callFunc) {
    cc.log("wb.wxData.initLoginData");
    var openid = wb.getItem("wxOpenid", "");
    if (openid.length > 0) {
        wb.wxData.openid = openid;
        if (callFunc) callFunc(openid);
        cc.log("wxOpenid=" + openid);
        return;
    }

    wb.wx.login({
        success: function (res) {
            var requestData = "js_code=" + res.code + "&pid=" + wb.wxConfig.pid;
            cc.log("wb.wxData.initLoginData3 " + requestData);
            wb.wxTool.httpRequest(wb.wxConfig.wxLoginUrl, requestData, function (data) {
                cc.log("wb.wxData.initLoginData4");
                // var sessionKey = data.session_key;
                wb.wxData.openid = data.openid;
                cc.log("wxOpenid=" + wb.wxData.openid);
                wb.setItem("wxOpenid", "" + wb.wxData.openid);
                if (callFunc) callFunc(wb.wxData.openid);
            }, false);
        },
        fail: function () {
            cc.log("login fail");
            if (callFunc) callFunc(null);
        }
    });
};

// 用户信息
wb.wxData.initUserInfo = function (callFunc) {
    wb.wx.getUserInfo({
            success: function (res) {
                cc.log("wb.wx.getUserInfo");
                cc.log(res.userInfo);
                wb.wxData.userInfo = res.userInfo;
                if (callFunc)callFunc(res.userInfo);
            },
            fail: function () {
                cc.log("getUserInfo fail");
                if (callFunc) callFunc(null);
            }
        }
    )
};

// 加载附加资源
wb.wxData.loadExtraData = function () {
    cc.loader.load(wb.wxRes,
        function (result, count, loadedCount) {
        }, function () {
        });
};
