/**
 * Created by cc on 2018/4/20.
 */

var wb = wb || {};

wb.HTTPRE = "httpre";

wb.wxTool = {
    loadImage: function (url, func) {
        cc.loader.loadImg(url, {isCrossOrigin: true}, function (err, img) {
            if (err) return cc.log(err);
            cc.log("img " + img);
            var texture2d = cc.loader.getRes(url);
            if (!texture2d) {
                texture2d = new cc.Texture2D();
                texture2d.initWithElement(img);
                texture2d.handleLoadedTexture();
            }
            if (func) func(texture2d);
        });
    },
    httpRequest: function (url, data, func) {
        var xhr = cc.loader.getXMLHttpRequest();
        if (!xhr.onreadystatechange) {
            xhr.onreadystatechange = function () {
                if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status <= 207)) {
                    cc.log("response:\n" + xhr.responseText);
                    var data = null;
                    if (xhr.responseText.length > 0) data = wb.parse(xhr.responseText);
                    if (!data) return;
                    if (data) cc.log(data);
                    if (data && data.result_status == 1) {
                        wb.EventManager.dispatchCustomEvent(wb.HTTPRE, xhr.responseText);
                    }
                    if (func) func(data);
                }
            };
        }
        xhr.open("POST", url);
        xhr.setRequestHeader('content-type', 'application/x-www-form-urlencoded');
        xhr.send(data);
    },
    fxMessage: function (type, callFun) {
        cc.log("fxMessage1");
        if (!wb.wxData.shareData) return;
        var shareList = wb.wxData.shareData.shareList;
        if (!shareList) return;
        var sData = null;
        for (var i = 0; i < shareList.length; i++) {
            cc.log("shareData[i].placement " + shareList[i].placement);
            if (shareList[i].placement == type) {
                sData = shareList[i];
                break;
            }
        }
        cc.log("fxMessage2");
        if (!sData) return;
        cc.log("fxMessage3");
        var callF = function () {
        };
        if (callFun) callF = callFun;
        var data = {
            title: sData.title,
            imageUrl: sData.imageUrl,
            success: callF
        };
        wb.wx.shareAppMessage(data);
    }

    // fxMessage: function (title, image, callFun) {
    //     var titleStr = "title";
    //     var imagePath = "";
    //     var callF = function () {
    //     };
    //     if (title) titleStr = title;
    //     if (image) imagePath = image;
    //     if (callFun) callF = callFun;
    //     var data = {
    //         title: titleStr,
    //         imageUrl: imagePath,
    //         success: callF
    //     };
    //     this.shareAppMessage(data);
    // },
    // tj: function (eventID, value, type) {
    //     if (!Tool.userId) return;
    //
    //     var cType = "custom";
    //     if (type) cType = type;
    //     var data = {
    //         label: value
    //     };
    //     cc.log("onEvent:type=" + type + ",eventID=" + eventID);
    //     var tData = {
    //         type: cType,
    //         eventid: eventID,
    //         wxappid: Config.pid,
    //         openid: Tool.userId,
    //         data: data
    //     };
    //     this.httpRequest("https://tj.vzhifu.net/" + Config.pid, tData);
    // }
};


